/*
 File: xc_str.h
 Date and Time: Fri Jan 30 18:55:28 2015 
*/
#ifndef __xc_str_h__
#define __xc_str_h__ 1
#include "yacco2.h"
#include "yacco2_T_enumeration.h"
#include "yacco2_k_symbols.h"
#include "yacco2_err_symbols.h"
#include "yacco2_terminals.h"
#include "yacco2_characters.h"
extern yacco2::Thread_entry ITH_xc_str;

extern yacco2::State S1_Cxc_str;
namespace NS_xc_str {
yacco2::THR _YACCO2_CALL_TYPE
TH_xc_str(yacco2::Parser* Caller);// called thread
yacco2::THR_result _YACCO2_CALL_TYPE
PROC_TH_xc_str(yacco2::Parser* Caller);// called thread's twin the procedure
using namespace NS_yacco2_T_enum;// enumerate
using namespace yacco2;
struct fsm_rules_reuse_table_type{
 fsm_rules_reuse_table_type();
 int no_rules_entries_;
 Per_rule_s_reuse_table* per_rule_s_table_[2];
};
class Cxc_str: public yacco2::CAbs_fsm {
 public:
  enum rules_and_subrules{
   start_of_rule_list = NS_yacco2_T_enum::T_Enum::sum_total_T
   ,R_Rxc_str_ = 569//start_of_rule_list + 0
    ,rhs1_Rxc_str_ = 1
   ,R_Rquote_ = 570//start_of_rule_list + 2
    ,rhs1_Rquote_ = 2
  };
  //no of la sets = 2
  //no of states = 4
  Cxc_str();
  ~Cxc_str();
  void op();
  bool failed();
  void reduce_rhs_of_rule
      (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule);
  fsm_rules_reuse_table_type fsm_rules_reuse_table;
  static int rhs_to_rules_mapping_[3];
  
    public: 
    char ddd_[1024*32];
    int ddd_idx_;
    void copy_str_into_buffer(std::string* Str);
    void copy_kstr_into_buffer(const char* Str);
  
 };
struct Rxc_str;
struct Rquote;
struct Rxc_str:public yacco2::CAbs_lr1_sym {
  Rxc_str(yacco2::Parser* P);
  public:
  void sr1();
};

struct Rquote:public yacco2::CAbs_lr1_sym {
  Rquote(yacco2::Parser* P);
  public:
  void sr1();
};

} // end of namespace

#endif
